<template>
    <q-card-section class="fit" ref="parent">
        <q-resize-observer @resize="Resize"/>
        <div class="over" :style="Overline">
            {{ overline }}
        </div>
        <div class="main">
            <div :style="Value">
                {{ Metric }}
            </div>
            <div class="under" :style="Unit">
                {{ unit }}
            </div>
        </div>

    </q-card-section>
</template>
<style lang='scss' scoped>
.over {
    font-family: Raleway, 'sans-serif';
    text-transform: uppercase;
}

.main {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
    text-align: center;
}

.under {
    font-family: Raleway, 'sans-serif';
    text-transform: uppercase;
    text-align: center;
}
</style>
<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {MetricValue} from "src/classLibrary/Dashboard/SingeMetricQuery";
import {FormatDuration} from "src/classLibrary/Utility";

@Component
export default class SingleValueWidget extends Vue {
    @Prop() value!: MetricValue;
    @Prop() overline!: string;
    @Prop() unit!: string;


    get Metric(): string {
        return MetricValue.match(this.value, {
            Count(p0: number) {
                return p0.toFixed(2).ToFloat().toLocaleString();
            }, Duration(seconds: number) {
                return FormatDuration({seconds}, true);
            }
        })
    }


    get Unit() {
        const fontSize = (this.w / 25) + "px";
        return {
            fontSize,
        }
    }


    get Value() {
        const fontSize = (this.w / 10) + "px";
        return {
            fontSize,
        }
    }

    get Overline() {
        const fontSize = (this.w / 24) + "px";
        return {
            fontSize,
        }
    }

    w: number = 200;

    Resize() {
        const parent = (this.$refs.parent as any).$el as HTMLElement;
        this.w = parent.getBoundingClientRect().width;
    }

}
</script>


